/*
   G e n e r a t e d  by ex4-to-mq4 decompiler FREEWARE 4.0.509.5
   Website: H T tP:/ / WWW . M E Ta Q U o te S.n E T
   E-mail : Sup p OrT@ ME taq u o tEs .nE t
*/
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
#property show_inputs

#import "NsBridge.dll"
   int InitializeNetwork(string a0, string a1);
   int GetOutputData(double& a0[], double& a1[]);
#import

extern bool UseNeuralNetwork = TRUE;
extern bool UseFourierTransform = TRUE;
extern int FT.count = 120;
extern int FT.densityThreshold = 25;
int G_count_92 = 0;
double Gda_96[120];
double Gda_100[36];
int Gi_104 = 0;
int Gi_108 = 5;
int Gi_112 = 10;
int Gi_116 = 3;
int Gi_120 = 6;
double G_close_124 = 0.0;
double Gd_132 = 0.0;
double Gd_140 = 0.0;
double Gd_148 = 1.15;
double Gd_156 = 0.0;
double Gd_unused_164 = 0.0;
int Gi_172 = 0;
int Gi_176 = 0;
int Gi_180 = 0;
int Gi_184 = 0;
int Gi_188 = 0;
double Gda_192[1];
extern bool ShowInputs = FALSE;
double Gd_200 = 0.0;
double Gd_208 = 0.0;
double Gd_216 = 0.0;
double Gd_224 = 0.0;
double Gd_232 = 0.0;
double Gd_240 = 0.0;
double Gd_248 = 0.0;
double Gd_256 = 0.0;
double Gd_264 = 0.0;
extern int Method = 1;
extern int LastBar = 0;
extern int PastBars = 300;
extern double LPOrder = 0.6;
extern int FutBars = 24;
extern int HarmNo = 20;
extern double FreqTOL = 0.0001;
extern int BurgWin = 0;
double Gda_312[10000];
double Gda_316[10000];
int Gi_344;
int Gi_348;
int Gi_352;
int Gi_356;

int start() {
   if (IsStopped() == FALSE) {
      if (UseNeuralNetwork) {
         Comment("Neural Network: Calculating...");
         start_nn();
      }
      if (UseFourierTransform) start_extrapolator();
      Comment("Trend Predictor Pro [www.nnea.net]");
   }
   return (0);
}

int start_extrapolator() {
   ObjectsDeleteAll(0, OBJ_ARROW);
   G_count_92 = 0;
   for (int count_0 = 0; count_0 < FT.count; count_0++) {
      Comment("Processing FT[" + count_0 + "] FT density=", G_count_92);
      start_fourier();
      if (G_count_92 > FT.densityThreshold) break;
   }
   return (0);
}

int start_nn() {
   int Li_24;
   int Li_0 = Gi_104;
   double Ld_4 = 99999;
   int Li_12 = 2;
   int Li_16 = 0;
   for (int Li_20 = 5; Li_20 <= 10; Li_20++) {
      Li_24 = 0;
      Gi_108 = Li_20;
      Gi_104 = Li_0 + Li_24;
      UsingNN();
      if (Gd_264 < Ld_4) {
         Ld_4 = Gd_264;
         Li_12 = Li_20;
         Li_16 = Li_24;
      }
      Comment("NNTP PRO: Neural Network processing...");
   }
   Gi_108 = Li_12;
   Gi_104 = Li_0 + Li_16;
   UsingNN();
   double Ld_28 = MathAbs(G_close_124 - Gd_216);
   double Ld_36 = MathAbs(G_close_124 - Gd_232);
   double Ld_unused_44 = 50;
   double Ld_unused_52 = 50;
   DrawBar("UP ", 20, 20.0 * Gd_200);
   DrawBar("DN ", 35, 20.0 * Gd_208);
   double Ld_60 = 5.0 * (1 / Gd_264);
   DrawBar("Signal ", 50, Ld_60);
   DrawText("infotextavrUP", 10, 65, C'0x1D,0x94,0xF6', 14, "Arial", "Res " + DoubleToStr(Gd_216, Digits), 1);
   DrawText("infotextavrDN", 10, 80, C'0x1D,0x94,0xF6', 14, "Arial", "Sup " + DoubleToStr(Gd_232, Digits), 1);
   return (0);
}

void DrawBar(string As_0, int Ai_8, int Ai_12) {
   int Li_20;
   DrawText("xup" + As_0, 10, Ai_8, C'0x1D,0x94,0xF6', 14, "Arial", As_0, 1);
   DrawText("xupval" + As_0, 210, Ai_8, C'0x1D,0x94,0xF6', 14, "Arial", DoubleToStr(Ai_12, 0) + "%", 1);
   for (int count_16 = 0; count_16 < 10; count_16++) {
      Li_20 = 255;
      if (count_16 >= Ai_12 / 10) Li_20 = 16159773;
      DrawText("trend_bar" + count_16 + As_0, 13 * count_16 + 70, Ai_8, Li_20, 14, "Wingdings", "n", 1);
   }
}

int init() {
   int Li_4;
   MathSrand(TimeLocal());
   int datetime_0 = WindowTimeOnDropped();
   if (datetime_0 > 0) {
      Li_4 = iBarShift(Symbol(), Period(), datetime_0, TRUE);
      Gi_104 = Li_4;
   }
   return (0);
}

void CopyOutsToMatrix(double Ada_0[], double &Ada_4[]) {
   int arr_size_8 = ArraySize(Ada_4);
   for (int index_12 = 0; index_12 < Gi_188; index_12++) Ada_4[index_12] = Ada_0[index_12];
}

void CopyMatrixToInputs(double Ada_0[], double &Ada_4[]) {
   int arr_size_8 = ArraySize(Ada_0);
   for (int index_12 = 0; index_12 < Gi_184; index_12++) Ada_4[index_12] = Ada_0[Gi_188 + index_12];
}

void UsingNN() {
   int Li_0 = InitializeNetwork(TerminalPath() + "\\MQL4\\Libraries\\pr2.5.dll", TerminalPath() + "\\MQL4\\Libraries\\pr2.5.nsw");
   if (Li_0 != 0) {
      Alert("Neural Network Error");
      return;
   }
   InitWindow(Gda_192);
   GetWindowParams();
   ObjectsDeleteAll(0);
   FillMatrix(Gda_192);
   ObjectsDeleteAll(0);
   CopyMatrixToInputs(Gda_192, Gda_96);
   int Li_4 = GetOutputData(Gda_96, Gda_100);
   CopyOutsToMatrix(Gda_100, Gda_192);
   FillMatrix(Gda_192, 1);
}

void InitWindow(double Ada_0[1]) {
   Gi_172 = Gi_112 + Gi_116;
   Gi_176 = Gi_120 * 2;
   Gi_180 = Gi_172 * Gi_176;
   Gd_156 = Gi_112 * Gi_108;
   Gd_unused_164 = Gi_116 * Gi_108;
   Gi_184 = Gi_112 * Gi_176;
   Gi_188 = Gi_116 * Gi_176;
   ArrayResize(Gda_192, Gi_180);
}

void GetWindowParams() {
   G_close_124 = Close[Gi_104];
   double high_0 = High[ArrayMaximum(High, Gd_156 + 1.0, Gi_104)];
   double low_8 = Low[ArrayMinimum(Low, Gd_156 + 1.0, Gi_104)];
   double Ld_16 = MathAbs(G_close_124 - high_0);
   double Ld_24 = MathAbs(G_close_124 - low_8);
   double Ld_32 = MathMax(Ld_16, Ld_24);
   Gd_140 = Ld_32 * Gd_148;
   double Ld_40 = Gi_120;
   Gd_132 = Gd_140 / Ld_40;
}

void FillMatrix(double &Ada_0[1], bool Ai_4 = FALSE) {
   int datetime_36;
   double price_40;
   int datetime_48;
   double price_52;
   double Ld_60;
   double Ld_68;
   bool Li_76;
   double Ld_80;
   double Ld_88;
   color color_96;
   string name_8 = "obj" + ObjectsTotal();
   name_8 = "obj" + ObjectsTotal();
   ObjectCreate(name_8, OBJ_TREND, 0, xTime(Gi_104 + Gi_112 * Gi_108), G_close_124, xTime(Gi_104 - Gi_116 * Gi_108), G_close_124);
   ObjectSet(name_8, OBJPROP_RAY, FALSE);
   ObjectSet(name_8, OBJPROP_COLOR, Black);
   ObjectSet(name_8, OBJPROP_STYLE, STYLE_DOT);
   Gd_264 = 0;
   Gd_200 = 0;
   Gd_208 = 0;
   Gd_248 = 0;
   Gd_256 = 0;
   Gd_216 = 0;
   Gd_224 = 0;
   Gd_232 = 0;
   Gd_240 = 0;
   int count_16 = 0;
   int count_20 = 0;
   int index_24 = 0;
   for (int Li_28 = -Gi_116; Li_28 < Gi_112; Li_28++) {
      for (int Li_32 = -Gi_120; Li_32 < Gi_120; Li_32++) {
         datetime_36 = xTime(Gi_104 + (Li_28 + 1) * Gi_108);
         price_40 = G_close_124 + (Li_32 + 1) * Gd_132;
         datetime_48 = xTime(Gi_104 + Li_28 * Gi_108);
         price_52 = G_close_124 + Li_32 * Gd_132;
         name_8 = "obj" + ObjectsTotal();
         ObjectCreate(name_8, OBJ_RECTANGLE, 0, datetime_36, price_40, datetime_48, price_52);
         Ld_60 = High[ArrayMaximum(High, Gi_108, Gi_104 + Li_28 * Gi_108 + 1)];
         Ld_68 = Low[ArrayMinimum(Low, Gi_108, Gi_104 + Li_28 * Gi_108 + 1)];
         Li_76 = FALSE;
         Ld_80 = 0;
         if (Ld_60 >= price_40)
            if (Ld_68 >= price_40) Li_76 = TRUE;
         if (Ld_60 <= price_52)
            if (Ld_68 <= price_52) Li_76 = TRUE;
         if (Ld_60 > price_52) {
            if (Ld_68 <= price_52) {
               Ld_88 = Ld_60 - price_52;
               Ld_80 = Ld_88 / Gd_132;
            }
         }
         if (Ld_60 > price_40) {
            if (Ld_68 <= price_40) {
               Ld_88 = price_40 - Ld_68;
               Ld_80 = Ld_88 / Gd_132;
            }
         }
         if (Ld_60 >= price_40)
            if (Ld_68 <= price_52) Ld_80 = 1;
         if (Ld_60 <= price_40)
            if (Ld_68 >= price_52) Ld_80 = 1;
         if (Li_28 < 0) ObjectSet(name_8, OBJPROP_COLOR, Red);
         else ObjectSet(name_8, OBJPROP_COLOR, DimGray);
         color_96 = White;
         if (Ld_80 > 0.1) color_96 = C'0xA5,0xB5,0xA5';
         if (Ld_80 > 0.2) color_96 = C'0x96,0xB5,0x97';
         if (Ld_80 > 0.3) color_96 = C'0x86,0xB5,0x88';
         if (Ld_80 > 0.4) color_96 = C'0x77,0xB5,0x7A';
         if (Ld_80 > 0.5) color_96 = C'0x65,0xB5,0x68';
         if (Ld_80 > 0.6) color_96 = C'0x57,0xB5,0x5A';
         if (Ld_80 > 0.7) color_96 = C'0x47,0xB5,0x4A';
         if (Ld_80 > 0.8) color_96 = C'0x36,0xB5,0x3B';
         if (Ld_80 > 0.9) color_96 = C'0x28,0xB5,0x2D';
         if (Ld_80 >= 1.0) color_96 = C'0x17,0xB5,0x1C';
         ObjectSet(name_8, OBJPROP_COLOR, color_96);
         if (!Ai_4) {
            if (Li_76) Ada_0[index_24] = 0;
            else Ada_0[index_24] = 1;
            Ada_0[index_24] = Ld_80;
            if (Li_76) ObjectSet(name_8, OBJPROP_BACK, FALSE);
            else ObjectSet(name_8, OBJPROP_BACK, TRUE);
         } else {
            if (Ada_0[index_24] < 0.05) ObjectSet(name_8, OBJPROP_BACK, FALSE);
            else ObjectSet(name_8, OBJPROP_BACK, TRUE);
            color_96 = White;
            if (Ada_0[index_24] > 0.0) color_96 = C'0xFF,0xE5,0xE5';
            if (Ada_0[index_24] > 0.1) color_96 = C'0xFF,0xCC,0xCC';
            if (Ada_0[index_24] > 0.2) color_96 = C'0xFF,0xB2,0xB3';
            if (Ada_0[index_24] > 0.3) color_96 = C'0xFF,0x99,0x99';
            if (Ada_0[index_24] > 0.4) color_96 = C'0xFF,0x80,0x80';
            if (Ada_0[index_24] > 0.5) color_96 = C'0xFF,0x66,0x66';
            if (Ada_0[index_24] > 0.6) color_96 = C'0xFF,0x4C,0x4D';
            if (Ada_0[index_24] > 0.7) color_96 = C'0xFF,0x33,0x33';
            if (Ada_0[index_24] > 0.8) color_96 = C'0xFF,0x1A,0x1A';
            if (Ada_0[index_24] > 0.9) color_96 = Red;
            if (!ShowInputs)
               if (Li_28 >= 0) ObjectDelete(name_8);
            if (Li_28 < 0) ObjectSet(name_8, OBJPROP_BACK, TRUE);
            if (Li_28 < 0) ObjectSet(name_8, OBJPROP_COLOR, color_96);
            if (Ada_0[index_24] <= 0.0) ObjectDelete(name_8);
            if (Li_28 < 0 && Li_32 < 0) Gd_208 += Ada_0[index_24];
            if (Li_28 < 0 && Li_32 >= 0) Gd_200 += Ada_0[index_24];
            if (Li_28 < -1) Gd_264 += MathMin(MathAbs(1 - Ada_0[index_24]), MathAbs(0 - Ada_0[index_24]));
            if (Li_28 < 0) {
               Gd_248 += (price_40 + price_52) / 2.0 * Ada_0[index_24];
               Gd_256 += Ada_0[index_24];
               if (Li_32 >= 0) {
                  Gd_216 += (price_40 + price_52) / 2.0 * Ada_0[index_24];
                  Gd_224 += Ada_0[index_24];
               }
               if (Li_32 < 0) {
                  Gd_232 += (price_40 + price_52) / 2.0 * Ada_0[index_24];
                  Gd_240 += Ada_0[index_24];
               }
            }
         }
         ObjectSetText(name_8, DoubleToStr(index_24, 0) + " " + DoubleToStr(Ada_0[index_24], 2));
         count_16++;
         index_24++;
      }
      count_20++;
      count_16 = 0;
   }
   if (Gd_256 > 0.0) Gd_248 /= Gd_256;
   if (Gd_224 > 0.0) Gd_216 /= Gd_224;
   if (Gd_240 > 0.0) Gd_232 /= Gd_240;
   double Ld_100 = 4.0 * (Gd_248 - G_close_124);
   Ld_100 = G_close_124 + Ld_100;
   Gd_264 /= Gi_188;
   DrawForecastLine(G_close_124, Ld_100);
   DrawForecastLine(Gd_216, Gd_216);
   DrawForecastLine(Gd_232, Gd_232);
}

void DrawForecastLine(double A_price_0, double A_price_8) {
   string name_16 = "obj" + ObjectsTotal();
   ObjectCreate(name_16, OBJ_TREND, 0, xTime(Gi_104), A_price_0, xTime(Gi_104 - Gi_116 * Gi_108), A_price_8);
   ObjectSet(name_16, OBJPROP_RAY, FALSE);
   ObjectSet(name_16, OBJPROP_COLOR, Black);
   ObjectSet(name_16, OBJPROP_STYLE, STYLE_DOT);
}

int xTime(int Ai_0) {
   int Li_4 = 60 * Period();
   int Li_ret_8 = Time[Ai_0];
   if (Ai_0 < 0) Li_ret_8 = Time[0] + (-Ai_0) * Li_4;
   return (Li_ret_8);
}

void DrawText(string A_name_0, int A_x_8, int A_y_12, color A_color_16, int A_fontsize_20, string A_fontname_24, string A_text_32, int Ai_40) {
   string name_44 = A_name_0 + ".";
   ObjectDelete(name_44);
   ObjectCreate(name_44, OBJ_LABEL, 0, 0, 0);
   ObjectSet(name_44, OBJPROP_XDISTANCE, A_x_8);
   ObjectSet(name_44, OBJPROP_YDISTANCE, A_y_12);
   ObjectSet(name_44, OBJPROP_COLOR, A_color_16);
   ObjectSet(name_44, OBJPROP_BACK, FALSE);
   ObjectSetText(name_44, A_text_32, A_fontsize_20, A_fontname_24);
   name_44 = A_name_0;
   ObjectDelete(name_44);
   if (Ai_40) {
      ObjectCreate(name_44, OBJ_LABEL, 0, 0, 0);
      ObjectSet(name_44, OBJPROP_XDISTANCE, A_x_8 + 1);
      ObjectSet(name_44, OBJPROP_YDISTANCE, A_y_12 + 1);
      ObjectSet(name_44, OBJPROP_COLOR, Black);
      ObjectSet(name_44, OBJPROP_BACK, FALSE);
      ObjectSetText(name_44, A_text_32, A_fontsize_20, A_fontname_24);
   }
}

int start_fourier() {
   double Lda_12[];
   double Lda_16[];
   double Ld_24;
   double Ld_32;
   double Ld_40;
   double Ld_48;
   int Li_60;
   double Ld_68;
   double Ld_76;
   int Li_84;
   int Li_88;
   int Li_unused_92;
   bool Li_96;
   double Ld_100;
   int Li_108;
   double Ld_112;
   LastBar = Gi_104;
   Gi_352 = LastBar;
   Gi_344 = PastBars;
   Gi_356 = LPOrder * PastBars;
   Gi_348 = FutBars;
   if (Method > 1) Gi_348 = Gi_344 - Gi_356 - 1;
   if (HarmNo == 0) HarmNo = Gi_344;
   IndicatorShortName("Extrapolator");
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_NONE);
   ArrayInitialize(Gda_312, EMPTY_VALUE);
   ArrayInitialize(Gda_316, EMPTY_VALUE);
   double Ld_0 = 0.0;
   for (int index_8 = 0; index_8 < Gi_344; index_8++) Ld_0 += Open[index_8 + Gi_352];
   Ld_0 /= Gi_344;
   if (Method == 1) {
      for (index_8 = 0; index_8 < Gi_344; index_8++) {
         Gda_312[index_8] = Ld_0;
         if (index_8 <= Gi_348) Gda_316[index_8] = Ld_0;
      }
   } else {
      ArrayResize(Lda_12, Gi_356 + 1);
      ArrayResize(Lda_16, Gi_344);
      for (index_8 = 0; index_8 < Gi_344; index_8++) Lda_16[Gi_344 - 1 - index_8] = Open[index_8 + Gi_352] - Ld_0;
   }
   switch (Method) {
   case 1:
      for (int count_56 = 0; count_56 < HarmNo; count_56++) {
         Freq(Ld_24, Ld_32, Ld_40, Ld_48);
         for (index_8 = 0; index_8 < Gi_344; index_8++) {
            Gda_312[index_8] += (Ld_32 + Ld_40 * MathCos(Ld_24 * index_8) + Ld_48 * MathSin(Ld_24 * index_8));
            if (index_8 <= Gi_348) Gda_316[index_8] += (Ld_32 + Ld_40 * MathCos(Ld_24 * index_8) - Ld_48 * MathSin(Ld_24 * index_8));
         }
      }
      break;
   case 2:
      ACF(Lda_16, Gi_356, Lda_12);
      break;
   case 3:
      WBurg(Lda_16, Gi_356, BurgWin, Lda_12);
      break;
   case 4:
      HNBurg(Lda_16, Gi_356, Lda_12);
      break;
   case 5:
      Geom(Lda_16, Gi_356, Lda_12);
      break;
   case 6:
      Li_60 = 0;
      MCov(Lda_16, Gi_356, Lda_12, Li_60);
      if (Li_60 == 1) {
         Print("Terminated prematurely");
         return (0);
      }
      for (index_8 = Gi_356; index_8 >= 1; index_8--) Lda_12[index_8] = Lda_12[index_8 - 1];
   }
   if (Method > 1) {
      for (int Li_64 = Gi_356; Li_64 < Gi_344 + Gi_348; Li_64++) {
         Ld_68 = 0.0;
         for (index_8 = 1; index_8 <= Gi_356; index_8++) {
            if (Li_64 - index_8 < Gi_344) Ld_68 -= Lda_12[index_8] * (Lda_16[Li_64 - index_8]);
            else Ld_68 -= Lda_12[index_8] * (Gda_316[Li_64 - index_8 - Gi_344 + 1]);
         }
         if (Li_64 < Gi_344) Gda_312[Gi_344 - 1 - Li_64] = Ld_68;
         else Gda_316[Li_64 - Gi_344 + 1] = Ld_68;
      }
      Gda_316[0] = Gda_312[0];
      for (index_8 = 0; index_8 < Gi_344 - Gi_356; index_8++) {
         Gda_312[index_8] += Ld_0;
         Gda_316[index_8] += Ld_0;
      }
   }
   for (index_8 = 0; index_8 <= (Gi_348 - 1) / 2; index_8++) {
      Ld_76 = Gda_316[index_8];
      Gda_316[index_8] = Gda_316[Gi_348 - index_8];
      Gda_316[Gi_348 - index_8] = Ld_76;
   }
   for (index_8 = 1; index_8 <= Gi_348 - 1; index_8++) {
      Li_84 = 60 * Period();
      Li_88 = Time[LastBar] + Li_84 * index_8;
      Li_unused_92 = 1000;
      Li_96 = FALSE;
      Ld_100 = Gda_316[Gi_348 - index_8] - (Gda_316[Gi_348 - index_8 + 1]);
      Li_108 = 10;
      if (Symbol() == "GBPUSD") Li_108 = 20;
      if (Symbol() == "USDJPY") Li_108 = 20;
      if (Period() == PERIOD_M30) Li_108 = 10;
      if (Period() == PERIOD_D1) Li_108 = 40;
      Ld_112 = MathRound((Gda_316[Gi_348 - index_8]) / (Point * Li_108)) * (Point * Li_108);
      DrawMarker(Li_88, Ld_112, Li_96, "");
   }
   double Ld_120 = MathRand();
   PastBars = 200.0 * (Ld_120 / 32767.001) + 70.0;
   return (0);
}

void Freq(double &Ad_0, double &Ad_8, double &Ad_16, double &Ad_24) {
   double Lda_32[];
   double Ld_36;
   double Ld_44;
   ArrayResize(Lda_32, Gi_344);
   double Ld_52 = 0.0;
   double Ld_60 = 2.0;
   Lda_32[0] = Open[Gi_352] - Gda_312[0];
   while (MathAbs(Ld_52 - Ld_60) > FreqTOL) {
      Ld_52 = Ld_60;
      Lda_32[1] = Open[Gi_352 + 1] - Gda_312[1] + Ld_52 * Lda_32[0];
      Ld_36 = Lda_32[0] * Lda_32[1];
      Ld_44 = Lda_32[0] * Lda_32[0];
      for (int Li_68 = 2; Li_68 < Gi_344; Li_68++) {
         Lda_32[Li_68] = Open[Li_68 + Gi_352] - Gda_312[Li_68] + Ld_52 * (Lda_32[Li_68 - 1]) - (Lda_32[Li_68 - 2]);
         Ld_36 += (Lda_32[Li_68 - 1]) * (Lda_32[Li_68] + (Lda_32[Li_68 - 2]));
         Ld_44 += (Lda_32[Li_68 - 1]) * (Lda_32[Li_68 - 1]);
      }
      Ld_60 = Ld_36 / Ld_44;
   }
   Ad_0 = MathArccos(Ld_60 / 2.0);
   Fit(Ad_0, Ad_8, Ad_16, Ad_24);
}

void Fit(double Ad_0, double &Ad_8, double &Ad_16, double &Ad_24) {
   double Ld_108;
   double Ld_116;
   double Ld_32 = 0.0;
   double Ld_40 = 0.0;
   double Ld_48 = 0.0;
   double Ld_56 = 0.0;
   double Ld_64 = 0.0;
   double Ld_72 = 0.0;
   double Ld_80 = 0.0;
   double Ld_88 = 0.0;
   double Ld_96 = 0.0;
   for (int index_104 = 0; index_104 < Gi_344; index_104++) {
      Ld_108 = MathCos(Ad_0 * index_104);
      Ld_116 = MathSin(Ad_0 * index_104);
      Ld_32 += Ld_108;
      Ld_40 += Ld_116;
      Ld_48 += Ld_108 * Ld_108;
      Ld_56 += Ld_116 * Ld_116;
      Ld_64 += Ld_108 * Ld_116;
      Ld_72 += Open[index_104 + Gi_352] - Gda_312[index_104];
      Ld_80 += MathPow(Open[index_104 + Gi_352] - Gda_312[index_104], 2);
      Ld_88 += (Open[index_104 + Gi_352] - Gda_312[index_104]) * Ld_108;
      Ld_96 += (Open[index_104 + Gi_352] - Gda_312[index_104]) * Ld_116;
   }
   Ld_32 /= Gi_344;
   Ld_40 /= Gi_344;
   Ld_48 /= Gi_344;
   Ld_56 /= Gi_344;
   Ld_64 /= Gi_344;
   Ld_72 /= Gi_344;
   Ld_80 /= Gi_344;
   Ld_88 /= Gi_344;
   Ld_96 /= Gi_344;
   if (Ad_0 == 0.0) {
      Ad_8 = Ld_72;
      Ad_16 = 0.0;
      Ad_24 = 0.0;
      return;
   }
   double Ld_124 = MathPow(Ld_64 - Ld_32 * Ld_40, 2) - (Ld_48 - Ld_32 * Ld_32) * (Ld_56 - Ld_40 * Ld_40);
   Ad_16 = ((Ld_96 - Ld_72 * Ld_40) * (Ld_64 - Ld_32 * Ld_40) - (Ld_88 - Ld_72 * Ld_32) * (Ld_56 - Ld_40 * Ld_40)) / Ld_124;
   Ad_24 = ((Ld_88 - Ld_72 * Ld_32) * (Ld_64 - Ld_32 * Ld_40) - (Ld_96 - Ld_72 * Ld_40) * (Ld_48 - Ld_32 * Ld_32)) / Ld_124;
   Ad_8 = Ld_72 - Ad_16 * Ld_32 - Ad_24 * Ld_40;
}

void ACF(double Ada_0[], int Ai_4, double &Ada_8[]) {
   double Lda_16[];
   double Ld_20;
   double Ld_36;
   int Li_56;
   int Li_60;
   int arr_size_12 = ArraySize(Ada_0);
   ArrayResize(Lda_16, Ai_4 + 1);
   for (int index_48 = 0; index_48 <= Ai_4; index_48++) {
      Lda_16[index_48] = 0.0;
      for (int Li_44 = index_48; Li_44 < arr_size_12; Li_44++) Lda_16[index_48] += Ada_0[Li_44] * (Ada_0[Li_44 - index_48]);
   }
   double Ld_28 = Lda_16[0];
   for (int Li_52 = 1; Li_52 <= Ai_4; Li_52++) {
      Ld_20 = -Lda_16[Li_52];
      for (Li_44 = 1; Li_44 < Li_52; Li_44++) Ld_20 -= Ada_8[Li_44] * (Lda_16[Li_52 - Li_44]);
      Ld_20 /= Ld_28;
      Ada_8[Li_52] = Ld_20;
      Li_56 = Li_52 / 2;
      for (Li_44 = 1; Li_44 <= Li_56; Li_44++) {
         Li_60 = Li_52 - Li_44;
         Ld_36 = Ada_8[Li_44];
         Ada_8[Li_44] += Ld_20 * Ada_8[Li_60];
         if (Li_44 != Li_60) Ada_8[Li_60] += Ld_20 * Ld_36;
      }
      Ld_28 *= (1 - Ld_20 * Ld_20);
   }
}

void WBurg(double Ada_0[], int Ai_4, int Ai_8, double &Ada_12[]) {
   double Lda_20[];
   double Lda_24[];
   int Li_36;
   int Li_40;
   double Ld_44;
   double Ld_52;
   double Ld_60;
   double Ld_68;
   int arr_size_16 = ArraySize(Ada_0);
   ArrayResize(Lda_20, arr_size_16);
   ArrayResize(Lda_24, arr_size_16);
   for (int index_28 = 0; index_28 < arr_size_16; index_28++) {
      Lda_20[index_28] = Ada_0[index_28];
      Lda_24[index_28] = Ada_0[index_28];
   }
   for (int Li_32 = 1; Li_32 <= Ai_4; Li_32++) {
      Ld_52 = 0.0;
      Ld_60 = 0.0;
      if (Li_32 == 1) {
         for (index_28 = 2; index_28 < arr_size_16; index_28++) {
            Ld_52 += win(index_28, 2, arr_size_16, Ai_8) * (Ada_0[index_28 - 1]) * (Ada_0[index_28] + (Ada_0[index_28 - 2]));
            Ld_60 += win(index_28, 2, arr_size_16, Ai_8) * (Ada_0[index_28 - 1]) * (Ada_0[index_28 - 1]);
         }
         Ld_68 = (-Ld_52) / Ld_60 / 2.0;
         if (Ld_68 > 1.0) Ld_68 = 1.0;
         if (Ld_68 < -1.0) Ld_68 = -1.0;
      } else {
         for (index_28 = Li_32; index_28 < arr_size_16; index_28++) {
            Ld_52 += win(index_28, Li_32, arr_size_16, Ai_8) * Lda_20[index_28] * (Lda_24[index_28 - 1]);
            Ld_60 += win(index_28, Li_32, arr_size_16, Ai_8) * (Lda_20[index_28] * Lda_20[index_28] + (Lda_24[index_28 - 1]) * (Lda_24[index_28 - 1]));
         }
         Ld_68 = (-2.0 * Ld_52) / Ld_60;
      }
      Ada_12[Li_32] = Ld_68;
      Li_36 = Li_32 / 2;
      for (index_28 = 1; index_28 <= Li_36; index_28++) {
         Li_40 = Li_32 - index_28;
         Ld_44 = Ada_12[index_28];
         Ada_12[index_28] += Ld_68 * Ada_12[Li_40];
         if (index_28 != Li_40) Ada_12[Li_40] += Ld_68 * Ld_44;
      }
      if (Li_32 < Ai_4) {
         for (index_28 = arr_size_16 - 1; index_28 >= Li_32; index_28--) {
            Ld_44 = Lda_20[index_28];
            Lda_20[index_28] += Ld_68 * (Lda_24[index_28 - 1]);
            Lda_24[index_28] = Lda_24[index_28 - 1] + Ld_68 * Ld_44;
         }
      }
   }
}

double win(int Ai_0, int Ai_4, int Ai_8, int Ai_12) {
   if (Ai_12 == 0) return (1.0);
   if (Ai_12 == 1) return (0.54 - MathCos(3.1415926536 * (2.0 * (Ai_0 - Ai_4) + 1.0) / (Ai_8 - Ai_4)) / 2.0);
   if (Ai_12 == 2) return (6.0 * (Ai_0 - Ai_4 + 1.0) * (Ai_8 - Ai_0) / (Ai_8 - Ai_4) / (Ai_8 - Ai_4 + 1.0) / (Ai_8 - Ai_4 + 2.0));
   return (0.0);
}

void HNBurg(double Ada_0[], int Ai_4, double &Ada_8[]) {
   double Lda_16[];
   double Lda_20[];
   int Li_32;
   int Li_36;
   double Ld_40;
   double Ld_48;
   double Ld_56;
   double Ld_64;
   double Ld_72;
   int arr_size_12 = ArraySize(Ada_0);
   ArrayResize(Lda_16, arr_size_12);
   ArrayResize(Lda_20, arr_size_12);
   for (int index_24 = 0; index_24 < arr_size_12; index_24++) {
      Lda_16[index_24] = Ada_0[index_24];
      Lda_20[index_24] = Ada_0[index_24];
   }
   for (int Li_28 = 1; Li_28 <= Ai_4; Li_28++) {
      Ld_56 = 0.0;
      Ld_64 = 0.0;
      if (Li_28 == 1) {
         for (index_24 = 2; index_24 < arr_size_12; index_24++) {
            Ld_40 = (Ada_0[index_24 - 1]) * (Ada_0[index_24 - 1]);
            Ld_56 += Ld_40 * (Ada_0[index_24 - 1]) * (Ada_0[index_24] + (Ada_0[index_24 - 2]));
            Ld_64 += Ld_40 * (Ada_0[index_24 - 1]) * (Ada_0[index_24 - 1]);
         }
         Ld_72 = (-Ld_56) / Ld_64 / 2.0;
         if (Ld_72 > 1.0) Ld_72 = 1.0;
         if (Ld_72 < -1.0) Ld_72 = -1.0;
      } else {
         Ld_40 = 0.0;
         for (index_24 = 1; index_24 < Li_28; index_24++) Ld_40 += Ada_0[index_24] * Ada_0[index_24];
         for (index_24 = Li_28; index_24 < arr_size_12; index_24++) {
            Ld_56 += Ld_40 * Lda_16[index_24] * (Lda_20[index_24 - 1]);
            Ld_64 += Ld_40 * (Lda_16[index_24] * Lda_16[index_24] + (Lda_20[index_24 - 1]) * (Lda_20[index_24 - 1]));
            Ld_40 = Ld_40 + Ada_0[index_24] * Ada_0[index_24] - (Ada_0[index_24 - Li_28 + 1]) * (Ada_0[index_24 - Li_28 + 1]);
         }
         Ld_72 = (-2.0 * Ld_56) / Ld_64;
      }
      Ada_8[Li_28] = Ld_72;
      Li_32 = Li_28 / 2;
      for (index_24 = 1; index_24 <= Li_32; index_24++) {
         Li_36 = Li_28 - index_24;
         Ld_48 = Ada_8[index_24];
         Ada_8[index_24] += Ld_72 * Ada_8[Li_36];
         if (index_24 != Li_36) Ada_8[Li_36] += Ld_72 * Ld_48;
      }
      if (Li_28 < Ai_4) {
         for (index_24 = arr_size_12 - 1; index_24 >= Li_28; index_24--) {
            Ld_48 = Lda_16[index_24];
            Lda_16[index_24] += Ld_72 * (Lda_20[index_24 - 1]);
            Lda_20[index_24] = Lda_20[index_24 - 1] + Ld_72 * Ld_48;
         }
      }
   }
}

void Geom(double Ada_0[], int Ai_4, double &Ada_8[]) {
   double Lda_16[];
   double Lda_20[];
   int Li_32;
   int Li_36;
   double Ld_40;
   double Ld_48;
   double Ld_56;
   double Ld_64;
   double Ld_72;
   int arr_size_12 = ArraySize(Ada_0);
   ArrayResize(Lda_16, arr_size_12);
   ArrayResize(Lda_20, arr_size_12);
   for (int index_24 = 0; index_24 < arr_size_12; index_24++) {
      Lda_16[index_24] = Ada_0[index_24];
      Lda_20[index_24] = Ada_0[index_24];
   }
   for (int Li_28 = 1; Li_28 <= Ai_4; Li_28++) {
      Ld_48 = 0.0;
      Ld_56 = 0.0;
      Ld_64 = 0.0;
      for (index_24 = Li_28; index_24 < arr_size_12; index_24++) {
         Ld_48 += Lda_16[index_24] * (Lda_20[index_24 - 1]);
         Ld_56 += Lda_16[index_24] * Lda_16[index_24];
         Ld_64 += (Lda_20[index_24 - 1]) * (Lda_20[index_24 - 1]);
      }
      Ld_72 = (-Ld_48) / MathSqrt(Ld_56) / MathSqrt(Ld_64);
      Ada_8[Li_28] = Ld_72;
      Li_32 = Li_28 / 2;
      for (index_24 = 1; index_24 <= Li_32; index_24++) {
         Li_36 = Li_28 - index_24;
         Ld_40 = Ada_8[index_24];
         Ada_8[index_24] += Ld_72 * Ada_8[Li_36];
         if (index_24 != Li_36) Ada_8[Li_36] += Ld_72 * Ld_40;
      }
      if (Li_28 < Ai_4) {
         for (index_24 = arr_size_12 - 1; index_24 >= Li_28; index_24--) {
            Ld_40 = Lda_16[index_24];
            Lda_16[index_24] += Ld_72 * (Lda_20[index_24 - 1]);
            Lda_20[index_24] = Lda_20[index_24 - 1] + Ld_72 * Ld_40;
         }
      }
   }
}

void MCov(double Ada_0[], int Ai_4, double &Ada_8[], int &Ai_12) {
   double Lda_20[];
   double Lda_24[];
   double Lda_28[];
   int Li_48;
   double Ld_84;
   double Ld_116;
   double Ld_124;
   double Ld_132;
   double Ld_140;
   double Ld_148;
   double Ld_156;
   double Ld_164;
   double Ld_172;
   double Ld_180;
   double Ld_188;
   double Ld_196;
   double Ld_204;
   double Ld_212;
   int arr_size_16 = ArraySize(Ada_0);
   ArrayResize(Lda_20, Ai_4 + 1);
   ArrayResize(Lda_24, Ai_4 + 1);
   ArrayResize(Lda_28, Ai_4);
   double Ld_52 = 0.0;
   for (int index_40 = 1; index_40 < arr_size_16 - 1; index_40++) Ld_52 += 2.0 * Ada_0[index_40] * Ada_0[index_40];
   double Ld_60 = (Ada_0[arr_size_16 - 1]) * (Ada_0[arr_size_16 - 1]);
   double Ld_68 = Ada_0[0] * Ada_0[0];
   double Ld_76 = 1.0 / (Ld_52 + 2.0 * (Ld_60 + Ld_68));
   double Ld_32 = Ld_52 + Ld_60 + Ld_68;
   double Ld_92 = 1.0 - Ld_60 * Ld_76;
   double Ld_100 = 1.0 - Ld_68 * Ld_76;
   double Ld_108 = Ada_0[0] * (Ada_0[arr_size_16 - 1]) * Ld_76;
   Lda_20[0] = Ada_0[0] * Ld_76;
   Lda_24[0] = (Ada_0[arr_size_16 - 1]) * Ld_76;
   int index_44 = 0;
   while (true) {
      Ld_140 = 0.0;
      for (index_40 = index_44 + 1; index_40 < arr_size_16; index_40++) Ld_140 += (Ada_0[arr_size_16 - 1 - index_40]) * (Ada_0[arr_size_16 - index_40 + index_44]);
      Ld_140 = 2.0 * Ld_140;
      Lda_28[index_44] = Ld_140;
      Ld_116 = Ada_0[0] * Lda_24[0];
      Ld_124 = Ada_0[0] * Lda_20[0];
      Ld_132 = (Ada_0[arr_size_16 - 1]) * Lda_24[0];
      if (index_44 > 0) {
         for (index_40 = 1; index_40 <= index_44; index_40++) {
            Ld_116 += Ada_0[index_40] * Lda_24[index_40];
            Ld_124 += Ada_0[index_40] * Lda_20[index_40];
            Ld_132 += (Ada_0[arr_size_16 - 1 - index_40]) * Lda_24[index_40];
            Lda_28[index_40 - 1] = Lda_28[index_40 - 1] - (Ada_0[index_44] * (Ada_0[index_44 - index_40]) + (Ada_0[arr_size_16 - 1 - index_44]) * (Ada_0[arr_size_16 - 1 - index_44 +
               index_40]));
            Ld_140 += (Lda_28[index_40 - 1]) * (Ada_8[index_44 - index_40]);
         }
      }
      Ld_172 = (-Ld_140) / Ld_32;
      Ada_8[index_44] = Ld_172;
      Ld_32 *= (1.0 - Ld_172 * Ld_172);
      if (index_44 > 0) {
         for (index_40 = 0; index_40 < (index_44 + 1) / 2; index_40++) {
            Li_48 = index_44 - index_40 - 1;
            Ld_140 = Ada_8[index_40];
            Ada_8[index_40] = Ld_140 + Ld_172 * Ada_8[Li_48];
            if (index_40 != Li_48) Ada_8[Li_48] += Ld_172 * Ld_140;
         }
      }
      if (index_44 == Ai_4 - 1) {
         Ld_32 *= 0.5 / (arr_size_16 - 1 - index_44);
         return;
      }
      Ld_52 = 1.0 / (Ld_92 * Ld_100 - Ld_108 * Ld_108);
      Ld_172 = (Ld_116 * Ld_108 + Ld_124 * Ld_92) * Ld_52;
      Ld_180 = (Ld_124 * Ld_108 + Ld_116 * Ld_100) * Ld_52;
      Ld_188 = (Ld_132 * Ld_108 + Ld_116 * Ld_92) * Ld_52;
      Ld_196 = (Ld_116 * Ld_108 + Ld_132 * Ld_100) * Ld_52;
      for (index_40 = 0; index_40 <= index_44 / 2; index_40++) {
         Li_48 = index_44 - index_40;
         Ld_140 = Lda_20[index_40];
         Ld_148 = Lda_24[index_40];
         Ld_156 = Lda_20[Li_48];
         Ld_164 = Lda_24[Li_48];
         Lda_20[index_40] += (Ld_172 * Ld_156 + Ld_180 * Ld_164);
         Lda_24[index_40] += (Ld_188 * Ld_156 + Ld_196 * Ld_164);
         if (index_40 != Li_48) {
            Lda_20[Li_48] += (Ld_172 * Ld_140 + Ld_180 * Ld_148);
            Lda_24[Li_48] += (Ld_188 * Ld_140 + Ld_196 * Ld_148);
         }
      }
      Ld_60 = Ld_124 * Ld_124;
      Ld_68 = Ld_116 * Ld_116;
      Ld_76 = Ld_132 * Ld_132;
      Ld_84 = Ld_100 - (Ld_60 * Ld_92 + Ld_68 * Ld_100 + 2.0 * Ld_124 * Ld_108 * Ld_116) * Ld_52;
      Ld_60 = Ld_92 - (Ld_68 * Ld_92 + Ld_76 * Ld_100 + 2.0 * Ld_116 * Ld_108 * Ld_132) * Ld_52;
      Ld_100 = Ld_84;
      Ld_92 = Ld_60;
      Ld_108 += Ld_188 * Ld_124 + Ld_196 * Ld_116;
      if (Ld_32 <= 0.0) {
         Print("Error: negative or zero variance in MCov");
         Ai_12 = 1;
         return;
      }
      if (Ld_92 <= 0.0 || Ld_92 > 1.0 || Ld_100 <= 0.0 || Ld_100 > 1.0) {
         Print("Error: delta and gamma are outside (0,1) in MCov");
         Ai_12 = 1;
         return;
      }
      Ld_52 = 1.0 / Ld_32;
      Ld_60 = 1.0 / (Ld_92 * Ld_100 - Ld_108 * Ld_108);
      Ld_204 = Ada_0[arr_size_16 - index_44 - 2];
      Ld_212 = Ada_0[index_44 + 1];
      for (index_40 = 0; index_40 <= index_44; index_40++) {
         Ld_204 += Ada_8[index_40] * (Ada_0[arr_size_16 - 1 - index_44 + index_40]);
         Ld_212 += Ada_8[index_40] * (Ada_0[index_44 - index_40]);
      }
      Ld_172 = Ld_212 * Ld_52;
      Ld_180 = Ld_204 * Ld_52;
      Ld_188 = (Ld_212 * Ld_92 + Ld_204 * Ld_108) * Ld_60;
      Ld_196 = (Ld_204 * Ld_100 + Ld_212 * Ld_108) * Ld_60;
      for (index_40 = index_44; index_40 >= 0; index_40--) {
         Ld_140 = Ada_8[index_40];
         Ada_8[index_40] = Ld_140 + Ld_188 * Lda_20[index_40] + Ld_196 * Lda_24[index_40];
         Lda_20[index_40 + 1] = Lda_20[index_40] + Ld_172 * Ld_140;
         Lda_24[index_40 + 1] = Lda_24[index_40] + Ld_180 * Ld_140;
      }
      Lda_20[0] = Ld_172;
      Lda_24[0] = Ld_180;
      Ld_68 = Ld_212 * Ld_212;
      Ld_76 = Ld_204 * Ld_204;
      Ld_32 -= (Ld_68 * Ld_92 + Ld_76 * Ld_100 + 2.0 * Ld_204 * Ld_212 * Ld_108) * Ld_60;
      Ld_92 -= Ld_76 * Ld_52;
      Ld_100 -= Ld_68 * Ld_52;
      Ld_108 += Ld_204 * Ld_212 * Ld_52;
      if (Ld_32 <= 0.0) {
         Print("Error: negative or zero variance in MCov");
         Ai_12 = 1;
         return;
      }
      if (Ld_92 <= 0.0 || Ld_92 > 1.0 || Ld_100 <= 0.0 || Ld_100 > 1.0) {
         Print("Error: delta and gamma are outside (0,1) in MCov");
         Ai_12 = 1;
         return;
      }
      index_44++;
   }
}

void DrawMarker(int A_datetime_0, double A_price_4, int Ai_unused_12, string As_unused_16) {
   int Li_32;
   int Li_36;
   int Li_40;
   int Li_44;
   color color_48;
   string name_24 = DoubleToStr(A_datetime_0, 0) + "_" + DoubleToStr(A_price_4, Digits);
   if (ObjectFind(name_24) == 0) {
      Li_32 = ObjectGet(name_24, OBJPROP_COLOR);
      Li_36 = GetRed(Li_32);
      Li_40 = GetBlue(Li_32);
      Li_44 = GetGreen(Li_32);
      color_48 = fromRGB(255, Li_44 - 15, Li_44 - 15);
      if (color_48 == Red) G_count_92++;
      ObjectSet(name_24, OBJPROP_COLOR, color_48);
      Li_36 = GetRed(color_48);
      Li_40 = GetBlue(color_48);
      Li_44 = GetGreen(color_48);
      return;
   }
   ObjectCreate(name_24, OBJ_ARROW, 0, A_datetime_0, A_price_4);
   ObjectSet(name_24, OBJPROP_ARROWCODE, 159);
   ObjectSet(name_24, OBJPROP_COLOR, fromRGB(255, 255, 255));
   ObjectSet(name_24, OBJPROP_WIDTH, 0);
}

int fromRGB(int Ai_0, int Ai_4, int Ai_8) {
   if (Ai_0 > 255) Ai_0 = 255;
   if (Ai_4 > 255) Ai_4 = 255;
   if (Ai_8 > 255) Ai_8 = 255;
   if (Ai_0 < 1) Ai_0 = 0;
   if (Ai_4 < 1) Ai_4 = 0;
   if (Ai_8 < 1) Ai_8 = 0;
   return (Ai_0 + Ai_4 * 256 + Ai_8 << 16);
}

int GetRed(int Ai_0) {
   int Li_ret_4 = Ai_0 >> 16 & 255;
   int Li_8 = Ai_0 >> 8 & 255;
   int Li_12 = Ai_0 & 255;
   return (Li_ret_4);
}

int GetBlue(int Ai_0) {
   int Li_4 = Ai_0 >> 16 & 255;
   int Li_8 = Ai_0 >> 8 & 255;
   int Li_ret_12 = Ai_0 & 255;
   return (Li_ret_12);
}

int GetGreen(int Ai_0) {
   int Li_4 = Ai_0 >> 16 & 255;
   int Li_ret_8 = Ai_0 >> 8 & 255;
   int Li_12 = Ai_0 & 255;
   return (Li_ret_8);
}